/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.GrupoRuta;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderGrupoRuta;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaGrupoRutaController")
@Scope("prototype")
public class BusquedaGrupoRutaController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<GrupoRuta> plwGrupoRuta;
    private MyListbox grupoRutaList;
    private Paging pagingGrupoRuta;
    private Textbox txtNome;

    public MyListbox getGrupoRutaList() {
        return grupoRutaList;
    }

    public void setGrupoRutaList(MyListbox grupoRutaList) {
        this.grupoRutaList = grupoRutaList;
    }

    public Paging getPagingGrupoRuta() {
        return pagingGrupoRuta;
    }

    public void setPagingGrupoRuta(Paging pagingGrupoRuta) {
        this.pagingGrupoRuta = pagingGrupoRuta;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        grupoRutaList.setItemRenderer(new RenderGrupoRuta());
        grupoRutaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                GrupoRuta c = (GrupoRuta) grupoRutaList.getSelected();
                verGrupoRuta(c);
            }
        });

        refreshLista();

        txtNome.focus();
    }

    private void verGrupoRuta(GrupoRuta c) {
        if (c == null) {
            return;
        }

        Map args = new HashMap();
        args.put("grupoRuta", c);
        args.put("grupoRutaList", grupoRutaList);

        openWindow("/gui/catalogos/editarGrupoRuta.zul",
                Labels.getLabel("editarGrupoRutaController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<GrupoRuta> grupoRutaBusqueda =
                new HibernateSearchObject<GrupoRuta>(GrupoRuta.class,
                pagingGrupoRuta.getPageSize());

        grupoRutaBusqueda.addFilterLike("descgrupo",
                "%" + txtNome.getText().trim().concat("%"));
        grupoRutaBusqueda.addFilterNotEqual("grupoRutaId", -1);

        grupoRutaBusqueda.addSortAsc("descgrupo");
        grupoRutaBusqueda.addFilterEqual("activo", Boolean.TRUE);

        plwGrupoRuta.init(grupoRutaBusqueda, grupoRutaList, pagingGrupoRuta);

        if (grupoRutaList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaGrupoRutaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verGrupoRuta(new GrupoRuta());
    }
}
